/*Esempio d'uso di funzioni (sottoprogrammi) - Simulazione di un sistema semaforico*/

#include <sota.h> 
#include <conio.h>
#include <stdio.h>
#include <iostream.h> 
#include <process.h>

unsigned int numero_di_secondi,delay,contatore, durata_beep_rosso_verde_giallo,durata_beep_giallo_lampeggiante;
char tasto;
/*dichiarazione dei prototipi delle funzioni*/
void accensione_rosso_verde(void);
void accensione_giallo(void);

void accensione_rosso_verde(void) /* dichiarazione del codice della funzione accensione_rosso_verde*/
      {
      do 
        {
         ritardo(delay);     
         suono("si",durata_beep_rosso_verde_giallo);
         printf("contatore = %u\n", contatore);
         contatore-=1;     
         if (kbhit()) exit(0);
        }while (contatore>0);   
      }
void accensione_giallo(void) /* dichiarazione del codice della funzione accensione_giallo*/
      {
      do 
        {
         ritardo(delay);     
         suono("fa",durata_beep_rosso_verde_giallo);
         printf("contatore = %u\n", contatore);
         contatore-=1;     
         if (kbhit()) exit(0);
        }while (contatore>0);   
      }

void accensione_giallo_lampeggiante(void) /* dichiarazione del codice della funzione accensione_giallo_lampeggiante*/
      {
      do 
        {
         ritardo(delay);     
         suono("do",durata_beep_giallo_lampeggiante);
         suono("mi",durata_beep_giallo_lampeggiante);
         suono("sol",durata_beep_giallo_lampeggiante);
         if (kbhit()) exit(0);
        }while (contatore>0);   
      }

int main()
{
delay = 1; /*1 secondo*/
durata_beep_rosso_verde_giallo = 100; /* 100 millisecondi*/
durata_beep_giallo_lampeggiante = 200; /* 200 millisecondi*/
for(;;)
   {
    cout<<"Accensione dei LED ROSSI per i veicoli che percorrrono la strada A\n";
    cout<<"Accensione dei LED VERDI per i veicoli che percorrrono la strada B\n";
    contatore = 10;
    accensione_rosso_verde();    
    cout<<"Accensione dei LED GIALLI per i veicoli che percorrrono la strada B\n";
    contatore = 5; 
    accensione_giallo();  
    cout<<"Accensione dei LED VERDI per i veicoli che percorrrono la strada A\n";
    cout<<"Accensione dei LED ROSSI per i veicoli che percorrrono la strada B\n";
    contatore = 10;
    accensione_rosso_verde();  
    cout<<"Accensione dei LED GIALLI per i veicoli che percorrrono la strada A\n";
    contatore=5;
    accensione_giallo();  
    cout<<"Premere il tasto g per attivare i LED GIALLI LAMPEGGIANTI (dopo le ore 22.00)\nPremere qualsiasi altro tasto per continuare\n";
    tasto=getch();
    if (tasto == 'g') for(;;)
                             {    
                              cout<<"LED GIALLI LAMPEGGIANTI\n";
                              accensione_giallo_lampeggiante();
                              if (kbhit()) break;   
                             }     
                                
    }

} 
